Subject: Re: bug#35780: [PATCH] attempt to fix polyglossia

From: Josh Holland <[email-masked]>
Date: Fri, 21 Jun 2019 16:40:06 +0100

Hi,

(CCing guix-devel because I'm confused about this and more eyes can't
hurt)

On Sat, May 18, 2019 at 05:50:13AM +0200, Ricardo Wurmus wrote:
> Thanks for giving it a try.  The build system works on “ins” files by
> default.  I guess it should try “dtx” files as well.

Should this be a patch to the build-system?  Although maybe it's not
that simple: https://ctan.org/texarchive/macros/xetex/latex/polyglossia
lists four files, incuding an "ins" file.

> We can patch the dtx file in a build phase and replace “../README” with
> just “README”.

I tried patching the README path as Ricardo suggested.  This got
somewhere, complaining of missing fonts, so I added texlive-fonts-cm
to native-inputs.  With both these changes, the build now fails while
trying to build example-thai.tex, and the errors appear to indicate
trying to build a LaTeX file with plain TeX:

Processing file polyglossia.dtx (example-thai.tex) -> example-thai.tex
File polyglossia.dtx ended by \endinput.
Lines  processed: 11224
Comments removed: 1600
Comments  passed: 215
Codelines passed: 9209

! Undefined control sequence.
l.209 \documentclass
                  [11pt]{ltxdoc}
! Undefined control sequence.
l.210 \usepackage
               {color}
! Undefined control sequence.
l.211 \usepackage
               {xspace,fancyvrb}
! Undefined control sequence.
l.212 \usepackage
               [neverdecrease]{paralist}
! Undefined control sequence.
l.213 \definecolor
                {myblue}{rgb}{0.02,0.04,0.48}
! Undefined control sequence.
l.214 \definecolor
                {lightblue}{rgb}{0.61,.8,.8}
! Undefined control sequence.
l.215 \definecolor
                {myred}{rgb}{0.65,0.04,0.07}
! Undefined control sequence.

(and more...)

I'm not that familiar with the intricacies of properly building TeXLive
from source, but the difference between the file list on CTAN and what
comes from the Subversion repo via texlive-ref smells fishy to me.  If I
manually run any permutation of  `{xe,lua}tex polyglossia.{ins,dtx}`
it mostly seems to build OK, but to my surprise no polyglossia.sty
is produced!  There's no actual build instructions in the README or the
polyglossia.pdf, so I'm rather lost here.

Thanks,

-- 
Josh Holland